Code

Use new semantics of is_bare/inside_git_dir/inside_work_tree
[git.git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be be taken to unexpected places.  If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
14 die() {
15         echo >&2 "$@"
16         exit 1
17 }
19 usage() {
20         die "Usage: $0 $USAGE"
21 }
23 set_reflog_action() {
24         if [ -z "${GIT_REFLOG_ACTION:+set}" ]
25         then
26                 GIT_REFLOG_ACTION="$*"
27                 export GIT_REFLOG_ACTION
28         fi
29 }
31 is_bare_repository () {
32         git-rev-parse --is-bare-repository
33 }
35 cd_to_toplevel () {
36         cdup=$(git-rev-parse --show-cdup)
37         if test ! -z "$cdup"
38         then
39                 cd "$cdup" || {
40                         echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
41                         exit 1
42                 }
43         fi
44 }
46 require_work_tree () {
47         test $(git-rev-parse --is-inside-work-tree) = true &&
48         test $(git-rev-parse --is-inside-git-dir) = false ||
49         die "fatal: $0 cannot be used without a working tree."
50 }
52 if [ -z "$LONG_USAGE" ]
53 then
54         LONG_USAGE="Usage: $0 $USAGE"
55 else
56         LONG_USAGE="Usage: $0 $USAGE
58 $LONG_USAGE"
59 fi
61 case "$1" in
62         -h|--h|--he|--hel|--help)
63         echo "$LONG_USAGE"
64         exit
65 esac
67 # Make sure we are in a valid repository of a vintage we understand.
68 if [ -z "$SUBDIRECTORY_OK" ]
69 then
70         : ${GIT_DIR=.git}
71         GIT_DIR=$(GIT_DIR="$GIT_DIR" git-rev-parse --git-dir) || {
72                 exit=$?
73                 echo >&2 "You need to run this command from the toplevel of the working tree."
74                 exit $exit
75         }
76 else
77         GIT_DIR=$(git-rev-parse --git-dir) || exit
78 fi
79 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}